#include <delays.h>
#include <i2c.h>
#include <stdlib.h>

//#define STROBE {E = 1; Delay1TCY(); Delay1TCY(); Delay1TCY(); Delay1TCY(); Delay1TCY(); Delay1TCY(); E = 0;};

char tnum[4],txt;

void start1307s(){
//START SIGNAL FOR DS1307***********
StartI2C1(); // issue start signal
WriteI2C1(0xD0); // address PCF8530
WriteI2C1(0); // start from word at address 0
WriteI2C1(0); // write 0 to config word (enable counting)
StopI2C1(); // issue stop signal
//**********************************
}


void readDS1307(char *sec, char *min1, char *hr, char *week_day, char *day, char *mn, char *year)
    {
    
	StartI2C1();
	WriteI2C1(0xD0);
	WriteI2C1(0x00);
	RestartI2C1();
	WriteI2C1(0xD1); //<--- corrected here
	*sec = ReadI2C1();
	AckI2C1();
	*min1 = ReadI2C1();
	AckI2C1();
	*hr = ReadI2C1();
	AckI2C1();
	*week_day = ReadI2C1();
	AckI2C1();
	*day = ReadI2C1();
	AckI2C1();
	*mn = ReadI2C1();
	AckI2C1();
	*year = ReadI2C1();
	NotAckI2C1();
	StopI2C1();

}


void writeDS1307()
 {
     StartI2C1();	
	WriteI2C1(0xD0);	
	WriteI2C1(0x00);	
	WriteI2C1(0x00);
	WriteI2C1(0x58); //minutes	
	WriteI2C1(0x22); // hours	
	WriteI2C1(0x06); //day	
	WriteI2C1(0x22); //date	
    WriteI2C1(0x12); //month	
	WriteI2C1(0x13); //year
	
	WriteI2C1(0x10);   // REG 7 - Enable squarewave output pin1hz 
	 	
	Delay1KTCYx(25);
	StopI2C1();
	
//	StartI2C1();
//	WriteI2C1(0xD0);
//	WriteI2C1(0x00);
//	WriteI2C1(0x00); //minutes
//	Delay1KTCYx(25);
//	StopI2C1();
}


void Zero_Fill(char *value) { // fill text representation
if (value[1] == 0) { // with leading zero
value[1] = value[0];
value[0] = 48;
value[2] = 0;
}
}


// -------------------- Formats date and time
void Transform_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year)
     {

*sec = ((*sec & 0x70) >> 4)*10 + (*sec & 0x0F);
*min = ((*min & 0xF0) >> 4)*10 + (*min & 0x0F);
*hr = ((*hr & 0x30) >> 4)*10 + (*hr & 0x0F);
*week_day =(*week_day & 0x07);
*day = ((*day & 0x3F) >> 4)*10 + (*day & 0x0F);
*mn = ((*mn & 0x10) >> 4)*10 + (*mn & 0x0F);
*year = ((*year & 0xF0)>>4)*10+(*year & 0x0F);
}





/*
//-------------------- Output values to LCD
void Display_Time(char sec, char min, char hr, char week_day, char day, char mn, char year) {

switch(week_day){
case 1: LCD_ConstTextOut(2,3,"Sun"); break;
case 2: LCD_ConstTextOut(2,3,"Mon"); break;
case 3: LCD_ConstTextOut(2,3,"Tue"); break;
case 4: LCD_ConstTextOut(2,3,"Wed"); break;
case 5: LCD_ConstTextOut(2,3,"Thu"); break;
case 6: LCD_ConstTextOut(2,3,"Fri"); break;
case 7: LCD_ConstTextOut(2,3,"Sat"); break;
}


btoa((day/10+48),tnum);
Zero_Fill(txt);
LCD_TextOut(2,7,txt);

btoa((day%10+48),tnum);
Zero_Fill(txt);
LCD_TextOut(2,8,txt);

btoa((mn/10+48),tnum);
Zero_Fill(txt);
LCD_TextOut(2,10,txt);

btoa((mn%10+48),tnum);
Zero_Fill(txt);
LCD_TextOut(2,11,txt);

btoa((day/10+48),tnum);
Zero_Fill(txt);
LCD_TextOut(2,17,txt);

btoa((day%10+48),tnum);
Zero_Fill(txt);
LCD_TextOut(2,18,txt);


}

void lastdate_check(char day, char mn, char year, int last_date)
{
if (mn == 1 || mn == 2 || mn ==4 || mn ==6 || mn == 8 || mn ==9 || mn == 11)
{
      last_date = 31;
      btoa(last_date,tnum);
      Zero_Fill(txt);
      LCD_TextOut(1,7,txt);
      
}
else
{
 if(mn == 3 )
 {
   if(year%4 == 0)
   {
                last_date = 29;
                btoa(last_date,tnum);
                Zero_Fill(txt);
                LCD_TextOut(1,7,txt);
             
   }
   else
   {
                last_date = 28;
                btoa(last_date,tnum);
                Zero_Fill(txt);
                LCD_TextOut(1,7,txt);
               
   }
 }

last_date = 30;
btoa(last_date,tnum);
Zero_Fill(txt);
LCD_TextOut(1,7,txt);

}
}

void lastmonth_check(char day, char mn, char year)
{
char last_mn;

if (mn>2)
{
char last_mn = mn - 1;
btoa(last_mn,tnum);
Zero_Fill(txt);
LCD_TextOut(1,11,txt);

}

else
{
last_mn = 12;
btoa(last_mn,tnum);
Zero_Fill(txt);
LCD_TextOut(1,11,txt);
}

}

void lastyear_check(char day,char mn,char year)
{
char last_year;

if (mn == 1)
{
 last_year = year-1;
 btoa(last_year,tnum);
 Zero_Fill(txt);
 LCD_TextOut(1,17,txt);
}
else
{
 btoa(year,tnum);
 Zero_Fill(txt);
 LCD_TextOut(1,17,txt);
}
}

*/