#include <usart.h>


void Init_UART1(void)
{
// USART_BRGH_HIGH,6  @ 1MHZ     
// USART_BRGH_HIGH,32 @ 10MHZ 
// USART_BRGH_HIGH,51 @ 16MHZ 
// USART_BRGH_HIGH,25 @ 8MHZ 
// init 19200Bd a 10Mhz avec IT en rx
// init 38400Bd a 20Mhz 
// voir para 18.5 spec sheet DS41159B page 186
/*#ifdef OSCILLATEUR_INTERNE
OSCCON=0b01110000;  //HFINTOSC  (16 MHz)
//111 = HFINTOSC  (16 MHz)
//110 = HFINTOSC/2  (8 MHz)
//101 = HFINTOSC/4  (4 MHz)
//100 = HFINTOSC/8  (2 MHz)
//011 = HFINTOSC/16  (1 MHz)(3)
#endif
*/
Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
USART_CONT_RX &
USART_BRGH_HIGH,130 );  // Q=10Mhzx 4(PLL)=40Mhz  19200bds
//USART_BRGH_HIGH,65 );  // Q=20Mhz  19200bds
//#ifdef OSCILLATEUR_INTERNE
// USART_BRGH_HIGH,13 );     // 4Mhz 19200 a 6% erreur
//USART_BRGH_HIGH,51 ); // 16MHz interne BRG16=0  19200bds sans PLL
// USART_BRGH_HIGH,25    // 16MHz interne BRG16=0  38400bds
// USART_BRGH_HIGH,208  // 16MHzxPLL soit 64Mhz  interne BRG16=0  19200bds
// USART_BRGH_HIGH,65  // Q=20Mhz  19200bds
//#else
//  USART_BRGH_HIGH,32 );  // Q=10Mhz 19200bds
//#endif
}

void Put_RS( unsigned char  untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}

void PutStr_RS( unsigned char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
}

void PutStrR_RS(rom unsigned char *s)
{
int n;
	for (n = 0; *s;n++ , s++)
	{
       	Put_RS(*s);
   	}
}

void PutR_RS( rom unsigned char * untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}

void CRLF()
{
    	PutStrR_RS((const rom char*)"\r\n");
}
    	

void Tempo(long L)
{
    while (L-->0);
}    
