#include <delays.h>
#include <i2c.h>
#include <stdlib.h>

extern unsigned char sec, min, hr, week_day, day, mn, year; 

void start1307s(){
//START SIGNAL FOR DS1307***********
StartI2C1(); // issue start signal
WriteI2C1(0xD0); // address PCF8530
WriteI2C1(0); // start from word at address 0
WriteI2C1(0); // write 0 to config word (enable counting)
StopI2C1(); // issue stop signal
//**********************************
}


//void readDS1307(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year)
void readDS1307()
    {
    
	StartI2C1();
	WriteI2C1(0xD0);
	WriteI2C1(0x00);
	RestartI2C1();
	WriteI2C1(0xD1); //<--- corrected here
	sec = ReadI2C1();
	AckI2C1();
	min = ReadI2C1();
   	AckI2C1();
	hr = ReadI2C1();
 	AckI2C1();
	week_day = ReadI2C1();
 	AckI2C1();
	day = ReadI2C1();
 	AckI2C1();
	mn = ReadI2C1();
 	AckI2C1();
	year = ReadI2C1();
	NotAckI2C1();
	StopI2C1();

}


void writeDS1307()
 {
     StartI2C1();	
	WriteI2C1(0xD0);	
	WriteI2C1(0x00);	
	WriteI2C1(0x00);// sec
	WriteI2C1(0x58);//minutes	
	WriteI2C1(0x22);// hours	
	WriteI2C1(0x06);//week_day	
	WriteI2C1(0x22);//date	
    WriteI2C1(0x12);//month	
	WriteI2C1(0x13);//year
	WriteI2C1(0x10);   // REG 7 - Enable squarewave output pin1hz 
	StopI2C1();
}

void _writeDS1307()
 {
     StartI2C1();	
	WriteI2C1(0xD0);	
	WriteI2C1(0x00);	
	WriteI2C1(sec);// sec
	WriteI2C1(min);//minutes	
	WriteI2C1(hr);// hours	
	WriteI2C1(week_day);//week_day	
	WriteI2C1(day);//date	
    WriteI2C1(mn);//month	
	WriteI2C1(year);//year
	WriteI2C1(0x10);   // REG 7 - Enable squarewave output pin1hz 
	StopI2C1();
}


// -------------------- Formats date and time
void Transform_Time(char s, char m, char h, char wd, char d, char mo, char y)
     {
sec = ((s & 0x70) >> 4)*10 + (s & 0x0F);
min = ((m & 0x70) >> 4)*10 + (m & 0x0F);
hr =  ((h  & 0x30) >> 4)*10 + (h & 0x0F);
week_day =(wd & 0x07);
day = ((d  & 0x30) >> 4)*10 + (d  & 0x0F);
mn =  ((mo   & 0x70) >> 4)*10 + (mo   & 0x0F);
year =((y & 0xF0) >> 4)*10 + (y & 0x0F);

}



