#include "p18f26k22.h"


// voir Help
//  Topics
//        Pic18
//            config bits settings
//                    choisir PIC18F26K22
#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSMP, PLLCFG=ON, PRICLKEN=ON ,FCMEN=OFF      // quartz 10Mhz
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0,CCP3MX=PORTB5
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5Lhello
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF                                                   // CONFIG7H

#include <p18cxxx.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <i2c.h>

#include <delays.h>
#include <usart.h>
#include "UART1/Uart1.h"
#include "UART1/Uart1.h"
#include "RTCC/I2C_RTC_DS1307.h"

#pragma udata

unsigned char  donnee,status;	
int i,j,k;
unsigned char sec, min, hr, week_day, day, mn, year;
unsigned char date,mth;




void main(void)
{
    TRISB = 0x00;
	PORTB = 0x00;
    ANSELC=0;       // <- pic18F26K22
   
    Init_UART1();
    PutStrR_RS((const rom char*)"\r\n Test DS1307  18F26K22 10MHz 13/12/2013  Mplab C18\r\n");


   OpenI2C1(MASTER,SLEW_OFF);
   Delay10KTCYx(250);
   
 // program get stuck without this  following line
   SSPADD = 24 ;  // at 10Mhz et  49 at 20MHz;
   StartI2C();
   IdleI2C();
   Delay10KTCYx(250);
   
   k=fprintf(_H_USART,"\r\n Init DS1307  :  31/12/2013 le 06 23H59M00S \n\r"); 
   sec=0x00;min=0x59;hr=0x23;week_day=6;
   day=0x31;mn=0x12;year=0x13;
   _writeDS1307();
 
   // writeDS1307();  // init time en dur !

while(1)
 {  day=0;mn=0;hr=0; sec=0;min=0;hr=0;week_day=0;year=0;
    k=fprintf(_H_USART,"\r\nLecture DS1307 avec fonctions I2C MPLAB \n\r"); 
    Delay10KTCYx(250);
   
    //readDS1307(sec,min,hr,week_day,day,mn,year);
    readDS1307();
    Transform_Time( sec, min, hr, week_day, day, mn, year);
   	k=fprintf(_H_USART,(const rom char*)" DS1307 lecture time (en decimal)%02d/%02d/20%02d le %02d %02dH %02dM %02dS \n\r",day,mn,year,week_day,hr,min,sec);  
    
  Delay10KTCYx(250);
  k=fprintf(_H_USART," Lecture DS1307 with other subroutines\n\r"); 
  ds1307_get_date();
  k=fprintf(_H_USART,(const rom char*)" DS1307 date %02d/%02d/20%02d/ le %2d \r\n",day,mn,year,week_day);
  ds1307_get_time();
  k=fprintf(_H_USART,(const rom char*)" DS1307 time %02dH%02dM%02dS \r\n",hr,min,sec);
 Delay10KTCYx(250);
  
}

}





